


#first of all, let's set the working directory
#to be the same as the current file.
#if Run-ing, this:
setwd(dirname(rstudioapi::getActiveDocumentContext()$path))
#if source-ing, this: 
#setwd(getSrcDirectory()[1])

library(tidyverse)
library(readr)
library(dplyr)
library(ggplot2)

#install.packages("tidytext")
#install.packages("stringr")
#install.packages("textdata")
 

library(tidytext)
library(stringr)


mystr="songs_assigned_to_testStudent.csv"
D1=read_csv(mystr)
filenames=list.files(pattern="*.txt")
baseNames=gsub("\\.txt$","", list.files(pattern="\\.txt$"))
 
D=D1 %>%
   arrange(SongID)


 

L=rep(NA,length(filenames))
V=rep(NA,length(filenames))

 for (i in 1:length(filenames)){
    lyrics = scan(filenames[[i]], quote=NULL, what="x")
    lyrics=gsub("\\.","",lyrics)
    lyrics=gsub("\\,","",lyrics)
    lyrics=gsub("\\$", "", lyrics) 
    
    
    tokens = tibble(text = lyrics) %>%
       unnest_tokens(word, text)
    
      
  L[i]=nrow(tokens)
  V[i]=nrow(unique(tokens))
  
  
 }

tempData=tibble(unlist(baseNames),L,V)
labels=c("SongID","Length","Vocab")
tempData=tempData %>% rename_all(~labels)

newData=D %>%
  inner_join(tempData,by="SongID") %>%
  filter(Length>10&Length<1000)%>%
  arrange(year)%>%
  select(Song,Performer,SongID,year,Length,Vocab)

strnew=str_remove(mystr,"songs_assigned_to_")
strnew= paste0("Project3Dataset_",strnew)
write_csv(newData,strnew)


 
